#!/usr/bin/perl -w
# Autor: Daniel Mohr
# Datum: 2009-07-19
# Version: 1.1
# Lizenz: GNU-GPL

# testefestplattengeschwindigkeit.pl

use strict;
use Time::HiRes qw(gettimeofday tv_interval);

my $i = 0;
my $hilfe = 0;
my $err = 0;
my $anzahl = 0;
my $anzahla = "";
my $bytes = 0;
my $bytesa = "";
my $datei = "";
my $loeschen = 1; # Datei soll geloescht werden
my $verbose = 0;
my $ordner = "";
my $ordneranzahl = 0; # soll mehrfach in einen Ordner geschrieben werden
my @schreibgeschwindigkeit = ();
my @lesegeschwindigkeit = ();
my $n = 0;
my $pre = "";
my @zeichen = ("a","b","c","d","e","f","g","h","i","j","k","l","m","n","o","p","q","r","s","t","u","v","w","x","y","z","A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R","S","T","U","V","W","X","Y","Z");
my $noperlflush = 0;
my $defaultoutputhandle = 0;

##################################### Parameter auswerten #####################################
if (@ARGV > 0)
  {
    for($i=0; $i<@ARGV; $i++)
      {
        if (($i < (@ARGV-1)) && ($ARGV[$i] eq "-a"))
          {
            $i++;
	    $anzahla = $ARGV[$i];
            $anzahl = eval($ARGV[$i]); # Anzahl der Schreibzugriffe
          } elsif (($i < (@ARGV-1)) && ($ARGV[$i] eq "-b")) {
            $i++;
	    $bytesa = $ARGV[$i];
            $bytes = eval($ARGV[$i]); # Anzahl Bytes, die geschrieben werden
          } elsif (($i < (@ARGV-1)) && ($ARGV[$i] eq "-d")) {
            $i++;
            $datei = $ARGV[$i]; # in diese Datei soll geschrieben werden
          } elsif (($i < (@ARGV-1)) && ($ARGV[$i] eq "-del")) {
            $i++;
            $loeschen = $ARGV[$i]; # soll die Datei geloescht werden
          } elsif (($i < (@ARGV-1)) && ($ARGV[$i] eq "-v")) {
            $i++;
            $verbose = $ARGV[$i]; # setzt die Ausfuehrlichkeit
          } elsif (($i < (@ARGV-2)) && ($ARGV[$i] eq "-o")) {
            $i++;
            $ordner = $ARGV[$i]; # setzt den Ordner
            $i++;
            $ordneranzahl = eval($ARGV[$i]); # setzt die Anzahl Dateien
          } elsif ($ARGV[$i] eq "-noperlflush") {
            $noperlflush = 1;
          } elsif ($ARGV[$i] eq "--help") {
            $hilfe = 1;
          }
      }
  } else {
    $hilfe = 1;
  }

if ($hilfe == 0)
  {
    if ($verbose > 1)
      {
	print "# ".$bytesa." = ".$bytes." zufaellige Bytes werden erzeugt:\n";
      }
    my $daten = "";
    my $start = [gettimeofday];
    for ($i=0; $i<$bytes; $i++)
      {
	$daten=$daten.chr(int(rand(256)));
      }
    if ($ordneranzahl > 0)
      {
	$pre = "";
	for ($i=0; $i<32; $i++)
	  {
	    $pre=$pre.$zeichen[int(rand(@zeichen))];
	  }
      }
    my $dauer = tv_interval ($start);
    ##################################### Schreiben #####################################
    for ($n=0; $n<max(1,$ordneranzahl); $n++)
      {
	if ($ordneranzahl > 0)
	  {
	    $datei = $ordner."/".$pre.$n;
	  }
	if ($verbose > 1)
	  {
	    print "# ".length($daten)." zufaellige Bytes werden ".$anzahla." = ".$anzahl."-mal in die Datei \"".$datei."\" geschrieben:\n";
	  }
	$start = [gettimeofday];
	open(SCHREIBEN,"> ".$datei) or die "Fehler beim Oeffnen von '".$datei."': $!\n";
	if ($noperlflush == 1)
	  {
	    $defaultoutputhandle = select(SCHREIBEN);
	    $| = 1;
	    select($defaultoutputhandle)
	  }
	for ($i=0; $i<$anzahl; $i++)
	  {
	    syswrite(SCHREIBEN,$daten,$bytes);
	  }
	close(SCHREIBEN);
	$dauer = tv_interval ($start);
	if ($verbose > 1)
	  {
	    print "Es wurden ".($bytes*$anzahl)." Bytes = ".($bytes*$anzahl/1024/1024)." MB geschrieben.\n";
	    print "Es hat ".$dauer." Sekunden gedauert.\n";
	  }
	$schreibgeschwindigkeit[$n] = (($bytes*$anzahl/1024/1024)/$dauer);
	if ($ordneranzahl == 0)
	  {
	    print "Schreibgeschwindigkeit: ".$schreibgeschwindigkeit[$n]." MB/sec.\n";
	  } else {
	    if ($verbose > 0) {
	      print $n.". Schreibgeschwindigkeit: ".$schreibgeschwindigkeit[$n]." MB/sec.\n";
	    }
	  }
      } # for $n
    if ($ordneranzahl > 0)
      {
	print "Schreibgeschwindigkeit: ".durchschnitt(@schreibgeschwindigkeit)." MB/sec.\n";
      }
    ##################################### Lesen #####################################
    for ($n=0; $n<max(1,$ordneranzahl); $n++)
      {
	if ($ordneranzahl > 0)
	  {
	    $datei = $ordner."/".$pre.$n;
	  }
	if ($verbose > 1)
	  {
	    print "# ".length($daten)." zufaellige Bytes werden ".$anzahla." = ".$anzahl."-mal aus der Datei \"".$datei."\" gelesen:\n";
	  }
	$start = [gettimeofday];
	open(LESEN,$datei) or die "Fehler beim Oeffnen von '".$datei."': $!\n";
	if ($noperlflush == 1)
	  {
	    $defaultoutputhandle = select(SCHREIBEN);
	    $| = 1;
	    select($defaultoutputhandle)
	  }
	for ($i=0; $i<$anzahl; $i++)
	  {
	    sysread(LESEN,$daten,$bytes);
	  }
	close(LESEN);
	$dauer = tv_interval ($start);
	if ($verbose > 1)
	  {
	    print "Es wurden ".($bytes*$anzahl)." Bytes = ".($bytes*$anzahl/1024/1024)." MB gelesen.\n";
	    print "Es hat ".$dauer." Sekunden gedauert.\n";
	  }
	$lesegeschwindigkeit[$n] = (($bytes*$anzahl/1024/1024)/$dauer);
	if ($ordneranzahl == 0)
	  {
	    print "Lesegeschwindigkeit: ".$lesegeschwindigkeit[$n]." MB/sec.\n";
	  } else {
	    if ($verbose > 0) {
	      print $n.". Lesegeschwindigkeit: ".$lesegeschwindigkeit[$n]." MB/sec.\n";
	    }
	  }
      } # for $n
    if ($ordneranzahl > 0)
      {
	print "Lesegeschwindigkeit: ".durchschnitt(@lesegeschwindigkeit)." MB/sec.\n";
      }
    if ($loeschen == 1)
      {
	if ($ordneranzahl > 0)
	  {
	    for ($n=0; $n<max(1,$ordneranzahl); $n++)
	      {
		$datei = $ordner."/".$pre.$n;
		unlink($datei);
	      }
	  } else {
	    unlink($datei);
	  }
      }
  } else {
    ##################################### Hilfe #####################################
    print "testefestplattengeschwindigkeit.pl\tV 1.1\nAutor: Daniel Mohr\tDatum: 2009-07-19\nLizenz: GNU-GPL\n\n";
    print "testefestplattengeschwindigkeit.pl -a <anzahl> -b <bytes> -d <datei>\n";
    print "\tschreibt und liest <anzahl>-mal <bytes> zufaellige Bytes in die Datei <datei>\n";
    print "\tund bestimmt dabei die Zeit und die Uebertragungsrate.\n";
    print "\tDie Datei <datei> wird anschliessend wieder geloescht.\n";
    print "\t<anzahl> und <bytes> koennen einfache Berechnugen sein.\n";
    print "optionale Parameter:\n";
    print "\t-del [w]\t[w] = 1: loescht die Datei <datei> wieder (default)\n";
    print "\t\t\t[w] = 0: loescht die Datei <datei> nicht\n";
    print "\t-o [o] [n]\terzeugt [n] Dateien im Ordner [o]\n";
    print "\t-v [v]\t\tsetzt die Ausfuehrlickeit auf [v]\n";
    print "\t-noperlflush \tsetzt die Perlvariable \$|=1, schaltet buffer von perl aus \n";
    print "\nUm den evtl. vorhandenen Cache des Arbeitsspeichers / der Festplatte  auszublenden\nsollte man mehr Daten schreiben/lesen als Arbeitsspeicher existiert.\n";
    print "\nBeispiele:\n";
    print " testefestplattengeschwindigkeit.pl -a 1024 -b 1024*1024 -d datei\n";
    print " testefestplattengeschwindigkeit.pl -a 10 -b 1024*1024 -o . 100\n";
    print " testefestplattengeschwindigkeit.pl -a 1 -b 1024*1024 -o . 10 -v 1\n";
  }

sub min
  {
    my $a=shift;
    my $b=shift;
    my $rueckgabe = 0;
    if ($a < $b)
      {
	$rueckgabe = $a;
      } else {
	$rueckgabe = $b;
      }
    return $rueckgabe;
  }

sub max
  {
    my $a=shift;
    my $b=shift;
    my $rueckgabe = 0;
    if ($a > $b)
      {
	$rueckgabe = $a;
      } else {
	$rueckgabe = $b;
      }
    return $rueckgabe;
  }

sub durchschnitt
  {
    my @werte = @_;
    my $d = 0;
    my $i = 0;
    my $n = @werte;
    for ($i=0; $i<$n; $i++)
      {
	$d = $d + $werte[$i];
      }
    $d = $d / $n;
    return $d;
  }
